﻿Imports WiimoteLib
Public Class Form1
    Private wm As New Wiimote
    Private wx_zero, wy_zero, wz_zero As Integer
    Private wx_now, wy_now, wz_now As Single
    Private wx_sum, wy_sum, wz_sum As Single
    Private wx, wy, wz As Long
    Private sw As New System.IO.StreamWriter("data.csv", True, System.Text.Encoding.GetEncoding("shift_jis"))
    Private Declare Function timeGetTime Lib "winmm" Alias "timeGetTime" () As Long
    Private save As Boolean
    Private starttime As Long
    Private passedtime As Long
    Private Timercount1, Timercount2, Timercount3 As Long
    Public Sub New()
        InitializeComponent()
    End Sub

    Private Sub ConnectButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ConnectButton.Click
        wm.Connect()
        wm.SetReportType(InputReport.IRExtensionAccel, True)
        wm.SetLEDs(False, True, True, False)
        ConnectButton.BackColor = Color.Pink
        '/////////////////静置時の値を一旦7885とする。
        wx_zero = 7885
        wy_zero = 7885
        wz_zero = 7885
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        Timercount2 = Timercount1
        Timercount1 = timeGetTime
        Dim ws As WiimoteState = wm.WiimoteState
        passedtime = Timercount1 - Timercount2
        BattBar.Value = ws.Battery
        batt_Val.Text = ws.Battery

        '///モードの表示/
        Yaw_ck.Checked = wm.WiimoteState.MotionPlusState.YawFast
        Pitch_ck.Checked = wm.WiimoteState.MotionPlusState.PitchFast
        Roll_ck.Checked = wm.WiimoteState.MotionPlusState.RollFast
        StateLbl.Text = wm.WiimoteState.ExtensionType.ToString()

        '///生データから各速度に変換。
        wx_now = (ws.MotionPlusState.RawValues.X - wx_zero) / 19.9 * (440 - 1560 * (wm.WiimoteState.MotionPlusState.YawFast)) / 440
        wy_now = (ws.MotionPlusState.RawValues.Y - wy_zero) / 19.0 * (440 - 1560 * (wm.WiimoteState.MotionPlusState.PitchFast)) / 440
        wz_now = (ws.MotionPlusState.RawValues.Z - wz_zero) / 16.6 * (440 - 1560 * (wm.WiimoteState.MotionPlusState.RollFast)) / 440

        '///積分してリモコンの傾き角を求める。
        If (Math.Abs(wx_now) > Sensitivitiy.Value) Then
            wx_sum = wx_sum + wx_now * (passedtime / 1000)
        End If
        If (Math.Abs(wy_now) > Sensitivitiy.Value) Then
            wy_sum = wy_sum + wy_now * (passedtime / 1000)
        End If
        If (Math.Abs(wz_now) > Sensitivitiy.Value) Then
            wz_sum = wz_sum + wz_now * (passedtime / 1000)
        End If

        If (Henkan_ck.Checked = True) Then
            '///生データチェックボックスがチェックされていたら、生データを表示。
            motionxval.Text = ws.MotionPlusState.RawValues.X
            motionyval.Text = ws.MotionPlusState.RawValues.Y
            motionzval.Text = ws.MotionPlusState.RawValues.Z
        Else
            motionxval.Text = Int(wx_now)
            motionyval.Text = Int(wy_now)
            motionzval.Text = Int(wz_now)
        End If

        '///傾き角を表示
        x_deg.Text = Int(wx_sum)
        y_deg.Text = Int(wy_sum)
        z_deg.Text = Int(wz_sum)

        '///図形描画
        WiimoteShape.X1 = 82 + 90 * Math.Sin(-(wx_sum) * Math.PI / 180)
        WiimoteShape.Y1 = 122 - (90 * Math.Cos(-(wx_sum) * Math.PI / 180))

        '///ファイルへの書き出し
        If (save = True) Then
            Timercount3 = Timercount1 - starttime
            'sw.WriteLine(Timercount3 & "," & wx_now & "," & wy_now & "," & wz_now & "," & wx_sum & "," & wy_sum & "," & wz_sum)
            sw.WriteLine(Timercount3 & "," & wx_zero & "," & ws.MotionPlusState.RawValues.X & "," & wx_now & "," & wx_sum)
        End If
    End Sub
    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As FormClosingEventArgs) Handles MyBase.FormClosing
        wm.SetLEDs(False, False, False, False)
        wm.Disconnect()
    End Sub

    Private Sub IniMotionPlus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles IniMotionPlus.Click
        wm.InitializeMotionPlus()
    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Henkan_ck.CheckedChanged
    End Sub

    Private Sub calib_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles calib.Click
        wx = 0
        wy = 0
        wz = 0

        '///静置状態にして、150ms間隔で50個データを取り、平均して校正。
        For i = 0 To 49
            Dim ws As WiimoteState = wm.WiimoteState
            wx = wx + ws.MotionPlusState.RawValues.X
            wy = wy + ws.MotionPlusState.RawValues.Y
            wz = wz + ws.MotionPlusState.RawValues.Z
            System.Threading.Thread.Sleep(150)
        Next i
        wx_zero = wx / 50
        wy_zero = wy / 50
        wz_zero = wz / 50

        wx_sum = 0
        wy_sum = 0
        wz_sum = 0
        Timercount1 = timeGetTime
    End Sub

    Private Sub Sum_reset_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Sum_reset.Click
        wx_sum = 0
        wy_sum = 0
        wz_sum = 0
    End Sub

    Private Sub Save_button_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Save_button.Click
        If save = False Then
            Save_button.Text = "記録中"
            Save_button.BackColor = Color.Pink
            save = True
            startTime = timeGetTime()
            'sw.WriteLine("timer" & "," & "wx_now" & "," & "wy_now" & "," & "wz_now" & "," & "wx_sum" & "," & "wy_sum" & "," & "wz_sum")
            sw.WriteLine("timer" & "," & "wx_zero" & "," & "wx_raw" & "," & "wx_now" & "," & "wx_sum")
        Else
            Save_button.Text = "記録"
            Save_button.BackColor = Color.Silver
            save = False
        End If
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Timercount1 = timeGetTime
    End Sub

    Private Sub Sensitivitiy_Scroll(ByVal sender As System.Object, ByVal e As System.Windows.Forms.ScrollEventArgs) Handles Sensitivitiy.Scroll
        Sensitivity_lbl.Text = Int(Sensitivitiy.Value)
    End Sub
End Class
